;Wacky Fun Random Numbar Generator
;Original idea by Nick Disabato
;
;Written in x86 ASM by Michael Vincent
;OS version

[org 0x0100]
[bits 16]

	;Set up registers
	;mov ax,cs
	;mov ds,ax
	;mov es,ax
	cli
	;mov ss,ax
	mov sp,0xFFFE
	sti
	;Generate a random NUMBAR, baby!
	xor ah,ah
	int 1Ah
	mov ax,dx
	mov cx,30
	xor dx,dx
	div cx
	inc dx
	push dx
	mov bp,sp
	;Clear screen!
	mov ax,0x0007
	int 10h
	;Set up cursor
	mov ah,1
	mov ch,ah	;note that this is really supposed to be the first scanline
	mov cl,12
	int 10h
	;Display welcome text!
	mov si,text1
	call dispstring
	mov si,prompt
	call dispstring
	xor bx,bx	;BX is the entered number & the number of entered characters
	push bx
	push bx
inputloop:
	;Input a number
	mov si,inputprompt
	call dispstring
	xor bx,bx
	mov [bp-2],bx
	mov [bp-4],bx
getkey:
	mov ah,0
	int 16h
	cmp ah,28
	je inputover
	cmp ah,14
	je backspace
	cmp al,'0'
	jb getkey
	cmp al,':'
	ja getkey
	cmp WORD [bp-4],2
	je getkey
	inc WORD [bp-4]
	push ax
	call outchar
	mov ax,10
	mul WORD [bp-2]
	mov bx,ax
	pop ax
	sub al,'0'
	xor ah,ah
	add ax,bx
	mov [bp-2],ax
	jmp getkey
backspace:
	cmp WORD [bp-4],0
	je getkey
	mov al,8
	call outchar
	mov al,' '
	call outchar
	mov al,8
	call outchar
	xor dx,dx
	mov ax,[bp-2]
	mov cx,10
	div cx
	mov [bp-2],ax
	dec WORD [bp-4]
	jmp getkey
inputover:
	mov ax,[bp-2]
	or ax,ax
	jz outofrange
	cmp ax,30
	ja outofrange
	cmp ax,WORD [bp-0]
	je yes
	mov si,no
	call dispstring
	jmp inputloop
outofrange:
	mov si,range
	call dispstring
	jmp inputloop
yes:
	mov si,nickd
	call dispstring
waitforenter:
	xor ah,ah
	int 16h
	cmp ah,28
	jne waitforenter
	int 19h
dispstring:
	lodsb
	or al,al
	jz dispstring_exit
	call outchar
	jmp dispstring
dispstring_exit:
	ret
outchar:
	xor bh,bh
	mov ah,0Eh
	int 10h
	ret

text1 db "Nick Disabato's /<-3R33+ Number Guessing Program", 0x0D, 0x0A, 0x00
prompt db "Choose a number from 1-30", 0x0D, 0x0A, 0x00
inputprompt db "A=?", 0x00
no db 0x0D, 0x0A, "That's not it!", 0x0D, 0x0A, 0x00
range db 0x0D, 0x0A, "Out of range!", 0x0D, 0x0A, 0x00
nickd db 0x0D, 0x0A, "Yes! Nick's ticalc.org password is **********", 0x00